unit Main;
{Example app can task switch using OnIdle or a timer}
{Undefine USETIMER to use OnIdle}
{$DEFINE USETIMER}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Dialogs, mtbase, StdCtrls, Spin, forms, ExtCtrls ;

type
  TForm1 = class(TForm)
    Label3: TLabel;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    L1: TLabel;
    Et1: TCheckBox;
    RadioButton1: TRadioButton;
    Button1: TButton;
    Button4: TButton;
    Button3: TButton;
    GroupBox2: TGroupBox;
    l2: TLabel;
    MinSlice: TLabel;
    SpinButton1: TSpinButton;
    et2: TCheckBox;
    Button2: TButton;
    Button5: TButton;
    DE: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TTask2 = Class(TThread)
    Procedure Run; override;
  end;

var
  Form1: TForm1;
  Task2 : TTask2;
  Task1Id : longint;

implementation

{$R *.DFM}

Procedure TTask1Run; far;
var
  t : integer;
  EE : Exception;
begin
  try
    repeat
      If CurrentId<>0 then
        SwitchThread
      else
        Application.ProcessMessages;
      Form1.l1.caption:=IntToStr(StrToInt(Form1.l1.caption)+1);
      form1.radiobutton1.checked:=not form1.radiobutton1.checked;
      If Form1.l1.caption='2000' then
        raise exception.create('200 error');
    until Form1.et1.checked;
    Form1.et1.Checked:=False;
  except
    On E: Exception do
      begin
        ShowMessage('Exception type '+E.Classname);
      end;
  end;
end;

Procedure TTask2.Run;
var
  t : longint;
begin
  repeat
    SwitchThread;
    sleep(500);
    Form1.l2.caption:=IntToStr(StrToInt(Form1.l2.caption)+1);
    Form1.MinSlice.Caption:=IntToStr(MinSlice);
  until Form1.et2.checked;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  r : longint;
begin
  r:=NewThread(Task2);
  If r<0 then showmessage('Error: '+teError(R));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnIdle := AppIdle;
  {$IFDEF USETIMER}
  Timer1.Enabled:=True;
  {$ELSE}
  Timer1.Enabled:=False;
  {$ENDIF}
  Task2:=TTask2.Create(50,tsPrivate,16384);
end;

procedure TForm1.AppIdle(Sender: TObject; var Done: Boolean);
begin
  {$IFNDEF USETIMER}
  SwitchThreadNow;
  {$ENDIF}
  If not Task2.Running and (Task2.DeathException<>nil) then
    Form1.DE.Caption:=task2.DeathException.Message
  else
    Form1.DE.Caption:='*';
  Done:=False;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Task1Id:=ThreadProcedure(TTask1Run,100,tsApplicationAuto,6000);
  if Task1Id<0 then ShowMessage('Error: '+teError(Task1Id));
end;

procedure TForm1.SpinButton1DownClick(Sender: TObject);
begin
  If task2.MinSlice>10 then
    Task2.MinSlice:=Task2.MinSlice-10
  else
    Task2.Minslice:=0;
end;

procedure TForm1.SpinButton1UpClick(Sender: TObject);
begin
  Task2.MinSlice:=Task2.MinSlice+10;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  If not RaiseOnThreadId(Task2.Id,Exception.Create('TEST ERROR')) then
    messagebeep(MB_ICONEXCLAMATION);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  TTask1Run;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  {$IFDEF USETIMER}
  If CurrentId=0 then
    SwitchThreadNow;
  {$ENDIF}
end;

begin
  SetRootStackTop(StackBottom-12000);
end.
